import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface BlockstorageVolumeV2Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#availability_zone BlockstorageVolumeV2#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#cascade BlockstorageVolumeV2#cascade}.
     *
     * @stability stable
     */
    readonly cascade?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#consistency_group_id BlockstorageVolumeV2#consistency_group_id}.
     *
     * @stability stable
     */
    readonly consistencyGroupId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#description BlockstorageVolumeV2#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#device_type BlockstorageVolumeV2#device_type}.
     *
     * @stability stable
     */
    readonly deviceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#image_id BlockstorageVolumeV2#image_id}.
     *
     * @stability stable
     */
    readonly imageId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#metadata BlockstorageVolumeV2#metadata}.
     *
     * @stability stable
     */
    readonly metadata?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#name BlockstorageVolumeV2#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#region BlockstorageVolumeV2#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#size BlockstorageVolumeV2#size}.
     *
     * @stability stable
     */
    readonly size: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#snapshot_id BlockstorageVolumeV2#snapshot_id}.
     *
     * @stability stable
     */
    readonly snapshotId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#source_replica BlockstorageVolumeV2#source_replica}.
     *
     * @stability stable
     */
    readonly sourceReplica?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#source_vol_id BlockstorageVolumeV2#source_vol_id}.
     *
     * @stability stable
     */
    readonly sourceVolId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#tags BlockstorageVolumeV2#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#volume_type BlockstorageVolumeV2#volume_type}.
     *
     * @stability stable
     */
    readonly volumeType?: string;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#timeouts BlockstorageVolumeV2#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: BlockstorageVolumeV2Timeouts;
}
/**
 * @stability stable
 */
export declare class BlockstorageVolumeV2Attachment extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get device(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get instanceId(): string;
}
/**
 * @stability stable
 */
export interface BlockstorageVolumeV2Timeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#create BlockstorageVolumeV2#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2#delete BlockstorageVolumeV2#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
export declare function blockstorageVolumeV2TimeoutsToTerraform(struct?: BlockstorageVolumeV2TimeoutsOutputReference | BlockstorageVolumeV2Timeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class BlockstorageVolumeV2TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): BlockstorageVolumeV2Timeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: BlockstorageVolumeV2Timeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2 opentelekomcloud_blockstorage_volume_v2}.
 *
 * @stability stable
 */
export declare class BlockstorageVolumeV2 extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/blockstorage_volume_v2 opentelekomcloud_blockstorage_volume_v2} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: BlockstorageVolumeV2Config);
    /**
     * @stability stable
     */
    attachment(index: string): BlockstorageVolumeV2Attachment;
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _cascade?;
    /**
     * @stability stable
     */
    get cascade(): boolean | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set cascade(value: boolean | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetCascade(): void;
    /**
     * @stability stable
     */
    get cascadeInput(): boolean | cdktf.IResolvable | undefined;
    private _consistencyGroupId?;
    /**
     * @stability stable
     */
    get consistencyGroupId(): string;
    /**
     * @stability stable
     */
    set consistencyGroupId(value: string);
    /**
     * @stability stable
     */
    resetConsistencyGroupId(): void;
    /**
     * @stability stable
     */
    get consistencyGroupIdInput(): string | undefined;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _deviceType?;
    /**
     * @stability stable
     */
    get deviceType(): string;
    /**
     * @stability stable
     */
    set deviceType(value: string);
    /**
     * @stability stable
     */
    resetDeviceType(): void;
    /**
     * @stability stable
     */
    get deviceTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _imageId?;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    set imageId(value: string);
    /**
     * @stability stable
     */
    resetImageId(): void;
    /**
     * @stability stable
     */
    get imageIdInput(): string | undefined;
    private _metadata?;
    /**
     * @stability stable
     */
    get metadata(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set metadata(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetMetadata(): void;
    /**
     * @stability stable
     */
    get metadataInput(): {
        [key: string]: string;
    } | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _size?;
    /**
     * @stability stable
     */
    get size(): number;
    /**
     * @stability stable
     */
    set size(value: number);
    /**
     * @stability stable
     */
    get sizeInput(): number | undefined;
    private _snapshotId?;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    /**
     * @stability stable
     */
    set snapshotId(value: string);
    /**
     * @stability stable
     */
    resetSnapshotId(): void;
    /**
     * @stability stable
     */
    get snapshotIdInput(): string | undefined;
    private _sourceReplica?;
    /**
     * @stability stable
     */
    get sourceReplica(): string;
    /**
     * @stability stable
     */
    set sourceReplica(value: string);
    /**
     * @stability stable
     */
    resetSourceReplica(): void;
    /**
     * @stability stable
     */
    get sourceReplicaInput(): string | undefined;
    private _sourceVolId?;
    /**
     * @stability stable
     */
    get sourceVolId(): string;
    /**
     * @stability stable
     */
    set sourceVolId(value: string);
    /**
     * @stability stable
     */
    resetSourceVolId(): void;
    /**
     * @stability stable
     */
    get sourceVolIdInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _volumeType?;
    /**
     * @stability stable
     */
    get volumeType(): string;
    /**
     * @stability stable
     */
    set volumeType(value: string);
    /**
     * @stability stable
     */
    resetVolumeType(): void;
    /**
     * @stability stable
     */
    get volumeTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get wwn(): string;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): BlockstorageVolumeV2TimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: BlockstorageVolumeV2Timeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): BlockstorageVolumeV2Timeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
