import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudComputeFlavorV2Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#availability_zone DataOpentelekomcloudComputeFlavorV2#availability_zone}.
     *
     * @stability stable
     */
    readonly availabilityZone?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#disk DataOpentelekomcloudComputeFlavorV2#disk}.
     *
     * @stability stable
     */
    readonly disk?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#flavor_id DataOpentelekomcloudComputeFlavorV2#flavor_id}.
     *
     * @stability stable
     */
    readonly flavorId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#min_disk DataOpentelekomcloudComputeFlavorV2#min_disk}.
     *
     * @stability stable
     */
    readonly minDisk?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#min_ram DataOpentelekomcloudComputeFlavorV2#min_ram}.
     *
     * @stability stable
     */
    readonly minRam?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#name DataOpentelekomcloudComputeFlavorV2#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#ram DataOpentelekomcloudComputeFlavorV2#ram}.
     *
     * @stability stable
     */
    readonly ram?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#region DataOpentelekomcloudComputeFlavorV2#region}.
     *
     * @stability stable
     */
    readonly region?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#resource_type DataOpentelekomcloudComputeFlavorV2#resource_type}.
     *
     * @stability stable
     */
    readonly resourceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#rx_tx_factor DataOpentelekomcloudComputeFlavorV2#rx_tx_factor}.
     *
     * @stability stable
     */
    readonly rxTxFactor?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#swap DataOpentelekomcloudComputeFlavorV2#swap}.
     *
     * @stability stable
     */
    readonly swap?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2#vcpus DataOpentelekomcloudComputeFlavorV2#vcpus}.
     *
     * @stability stable
     */
    readonly vcpus?: number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2 opentelekomcloud_compute_flavor_v2}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudComputeFlavorV2 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/compute_flavor_v2 opentelekomcloud_compute_flavor_v2} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudComputeFlavorV2Config);
    private _availabilityZone?;
    /**
     * @stability stable
     */
    get availabilityZone(): string;
    /**
     * @stability stable
     */
    set availabilityZone(value: string);
    /**
     * @stability stable
     */
    resetAvailabilityZone(): void;
    /**
     * @stability stable
     */
    get availabilityZoneInput(): string | undefined;
    private _disk?;
    /**
     * @stability stable
     */
    get disk(): number;
    /**
     * @stability stable
     */
    set disk(value: number);
    /**
     * @stability stable
     */
    resetDisk(): void;
    /**
     * @stability stable
     */
    get diskInput(): number | undefined;
    /**
     * @stability stable
     */
    extraSpecs(key: string): string | cdktf.IResolvable;
    private _flavorId?;
    /**
     * @stability stable
     */
    get flavorId(): string;
    /**
     * @stability stable
     */
    set flavorId(value: string);
    /**
     * @stability stable
     */
    resetFlavorId(): void;
    /**
     * @stability stable
     */
    get flavorIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _minDisk?;
    /**
     * @stability stable
     */
    get minDisk(): number;
    /**
     * @stability stable
     */
    set minDisk(value: number);
    /**
     * @stability stable
     */
    resetMinDisk(): void;
    /**
     * @stability stable
     */
    get minDiskInput(): number | undefined;
    private _minRam?;
    /**
     * @stability stable
     */
    get minRam(): number;
    /**
     * @stability stable
     */
    set minRam(value: number);
    /**
     * @stability stable
     */
    resetMinRam(): void;
    /**
     * @stability stable
     */
    get minRamInput(): number | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _ram?;
    /**
     * @stability stable
     */
    get ram(): number;
    /**
     * @stability stable
     */
    set ram(value: number);
    /**
     * @stability stable
     */
    resetRam(): void;
    /**
     * @stability stable
     */
    get ramInput(): number | undefined;
    private _region?;
    /**
     * @stability stable
     */
    get region(): string;
    /**
     * @stability stable
     */
    set region(value: string);
    /**
     * @stability stable
     */
    resetRegion(): void;
    /**
     * @stability stable
     */
    get regionInput(): string | undefined;
    private _resourceType?;
    /**
     * @stability stable
     */
    get resourceType(): string;
    /**
     * @stability stable
     */
    set resourceType(value: string);
    /**
     * @stability stable
     */
    resetResourceType(): void;
    /**
     * @stability stable
     */
    get resourceTypeInput(): string | undefined;
    private _rxTxFactor?;
    /**
     * @stability stable
     */
    get rxTxFactor(): number;
    /**
     * @stability stable
     */
    set rxTxFactor(value: number);
    /**
     * @stability stable
     */
    resetRxTxFactor(): void;
    /**
     * @stability stable
     */
    get rxTxFactorInput(): number | undefined;
    private _swap?;
    /**
     * @stability stable
     */
    get swap(): number;
    /**
     * @stability stable
     */
    set swap(value: number);
    /**
     * @stability stable
     */
    resetSwap(): void;
    /**
     * @stability stable
     */
    get swapInput(): number | undefined;
    private _vcpus?;
    /**
     * @stability stable
     */
    get vcpus(): number;
    /**
     * @stability stable
     */
    set vcpus(value: number);
    /**
     * @stability stable
     */
    resetVcpus(): void;
    /**
     * @stability stable
     */
    get vcpusInput(): number | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
