import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataOpentelekomcloudLbLoadbalancerV3Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#l4_flavor DataOpentelekomcloudLbLoadbalancerV3#l4_flavor}.
     *
     * @stability stable
     */
    readonly l4Flavor?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#l7_flavor DataOpentelekomcloudLbLoadbalancerV3#l7_flavor}.
     *
     * @stability stable
     */
    readonly l7Flavor?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#name DataOpentelekomcloudLbLoadbalancerV3#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#router_id DataOpentelekomcloudLbLoadbalancerV3#router_id}.
     *
     * @stability stable
     */
    readonly routerId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#subnet_id DataOpentelekomcloudLbLoadbalancerV3#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#vip_address DataOpentelekomcloudLbLoadbalancerV3#vip_address}.
     *
     * @stability stable
     */
    readonly vipAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3#vip_port_id DataOpentelekomcloudLbLoadbalancerV3#vip_port_id}.
     *
     * @stability stable
     */
    readonly vipPortId?: string;
}
/**
 * @stability stable
 */
export declare class DataOpentelekomcloudLbLoadbalancerV3PublicIp extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get address(): string;
    /**
     * @stability stable
     */
    get bandwidthChargeMode(): string;
    /**
     * @stability stable
     */
    get bandwidthName(): string;
    /**
     * @stability stable
     */
    get bandwidthShareType(): string;
    /**
     * @stability stable
     */
    get bandwidthSize(): number;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipType(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3 opentelekomcloud_lb_loadbalancer_v3}.
 *
 * @stability stable
 */
export declare class DataOpentelekomcloudLbLoadbalancerV3 extends cdktf.TerraformDataSource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/d/lb_loadbalancer_v3 opentelekomcloud_lb_loadbalancer_v3} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: DataOpentelekomcloudLbLoadbalancerV3Config);
    /**
     * @stability stable
     */
    get adminStateUp(): cdktf.IResolvable;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    get createdAt(): string;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get ipTargetEnable(): cdktf.IResolvable;
    private _l4Flavor?;
    /**
     * @stability stable
     */
    get l4Flavor(): string;
    /**
     * @stability stable
     */
    set l4Flavor(value: string);
    /**
     * @stability stable
     */
    resetL4Flavor(): void;
    /**
     * @stability stable
     */
    get l4FlavorInput(): string | undefined;
    private _l7Flavor?;
    /**
     * @stability stable
     */
    get l7Flavor(): string;
    /**
     * @stability stable
     */
    set l7Flavor(value: string);
    /**
     * @stability stable
     */
    resetL7Flavor(): void;
    /**
     * @stability stable
     */
    get l7FlavorInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get networkIds(): string[];
    /**
     * @stability stable
     */
    publicIp(index: string): DataOpentelekomcloudLbLoadbalancerV3PublicIp;
    private _routerId?;
    /**
     * @stability stable
     */
    get routerId(): string;
    /**
     * @stability stable
     */
    set routerId(value: string);
    /**
     * @stability stable
     */
    resetRouterId(): void;
    /**
     * @stability stable
     */
    get routerIdInput(): string | undefined;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    resetSubnetId(): void;
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    /**
     * @stability stable
     */
    tags(key: string): string | cdktf.IResolvable;
    /**
     * @stability stable
     */
    get updatedAt(): string;
    private _vipAddress?;
    /**
     * @stability stable
     */
    get vipAddress(): string;
    /**
     * @stability stable
     */
    set vipAddress(value: string);
    /**
     * @stability stable
     */
    resetVipAddress(): void;
    /**
     * @stability stable
     */
    get vipAddressInput(): string | undefined;
    private _vipPortId?;
    /**
     * @stability stable
     */
    get vipPortId(): string;
    /**
     * @stability stable
     */
    set vipPortId(value: string);
    /**
     * @stability stable
     */
    resetVipPortId(): void;
    /**
     * @stability stable
     */
    get vipPortIdInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
