import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DcsInstanceV1Config extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#access_user DcsInstanceV1#access_user}.
     *
     * @stability stable
     */
    readonly accessUser?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#available_zones DcsInstanceV1#available_zones}.
     *
     * @stability stable
     */
    readonly availableZones: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_at DcsInstanceV1#backup_at}.
     *
     * @stability stable
     */
    readonly backupAt?: number[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_type DcsInstanceV1#backup_type}.
     *
     * @stability stable
     */
    readonly backupType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#begin_at DcsInstanceV1#begin_at}.
     *
     * @stability stable
     */
    readonly beginAt?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#capacity DcsInstanceV1#capacity}.
     *
     * @stability stable
     */
    readonly capacity: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#description DcsInstanceV1#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#engine DcsInstanceV1#engine}.
     *
     * @stability stable
     */
    readonly engine: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#engine_version DcsInstanceV1#engine_version}.
     *
     * @stability stable
     */
    readonly engineVersion: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#maintain_begin DcsInstanceV1#maintain_begin}.
     *
     * @stability stable
     */
    readonly maintainBegin?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#maintain_end DcsInstanceV1#maintain_end}.
     *
     * @stability stable
     */
    readonly maintainEnd?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#name DcsInstanceV1#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#password DcsInstanceV1#password}.
     *
     * @stability stable
     */
    readonly password: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#period_type DcsInstanceV1#period_type}.
     *
     * @stability stable
     */
    readonly periodType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#product_id DcsInstanceV1#product_id}.
     *
     * @stability stable
     */
    readonly productId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#save_days DcsInstanceV1#save_days}.
     *
     * @stability stable
     */
    readonly saveDays?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#security_group_id DcsInstanceV1#security_group_id}.
     *
     * @stability stable
     */
    readonly securityGroupId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#subnet_id DcsInstanceV1#subnet_id}.
     *
     * @stability stable
     */
    readonly subnetId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#vpc_id DcsInstanceV1#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId: string;
    /**
     * backup_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_policy DcsInstanceV1#backup_policy}
     *
     * @stability stable
     */
    readonly backupPolicy?: DcsInstanceV1BackupPolicy;
    /**
     * configuration block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#configuration DcsInstanceV1#configuration}
     *
     * @stability stable
     */
    readonly configuration?: DcsInstanceV1Configuration[] | cdktf.IResolvable;
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#timeouts DcsInstanceV1#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: DcsInstanceV1Timeouts;
}
/**
 * @stability stable
 */
export interface DcsInstanceV1BackupPolicy {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_at DcsInstanceV1#backup_at}.
     *
     * @stability stable
     */
    readonly backupAt: number[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#backup_type DcsInstanceV1#backup_type}.
     *
     * @stability stable
     */
    readonly backupType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#begin_at DcsInstanceV1#begin_at}.
     *
     * @stability stable
     */
    readonly beginAt: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#period_type DcsInstanceV1#period_type}.
     *
     * @stability stable
     */
    readonly periodType: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#save_days DcsInstanceV1#save_days}.
     *
     * @stability stable
     */
    readonly saveDays?: number;
}
export declare function dcsInstanceV1BackupPolicyToTerraform(struct?: DcsInstanceV1BackupPolicyOutputReference | DcsInstanceV1BackupPolicy): any;
/**
 * @stability stable
 */
export declare class DcsInstanceV1BackupPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DcsInstanceV1BackupPolicy | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DcsInstanceV1BackupPolicy | undefined);
    private _backupAt?;
    /**
     * @stability stable
     */
    get backupAt(): number[];
    /**
     * @stability stable
     */
    set backupAt(value: number[]);
    /**
     * @stability stable
     */
    get backupAtInput(): number[] | undefined;
    private _backupType?;
    /**
     * @stability stable
     */
    get backupType(): string;
    /**
     * @stability stable
     */
    set backupType(value: string);
    /**
     * @stability stable
     */
    resetBackupType(): void;
    /**
     * @stability stable
     */
    get backupTypeInput(): string | undefined;
    private _beginAt?;
    /**
     * @stability stable
     */
    get beginAt(): string;
    /**
     * @stability stable
     */
    set beginAt(value: string);
    /**
     * @stability stable
     */
    get beginAtInput(): string | undefined;
    private _periodType?;
    /**
     * @stability stable
     */
    get periodType(): string;
    /**
     * @stability stable
     */
    set periodType(value: string);
    /**
     * @stability stable
     */
    get periodTypeInput(): string | undefined;
    private _saveDays?;
    /**
     * @stability stable
     */
    get saveDays(): number;
    /**
     * @stability stable
     */
    set saveDays(value: number);
    /**
     * @stability stable
     */
    resetSaveDays(): void;
    /**
     * @stability stable
     */
    get saveDaysInput(): number | undefined;
}
/**
 * @stability stable
 */
export interface DcsInstanceV1Configuration {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#parameter_id DcsInstanceV1#parameter_id}.
     *
     * @stability stable
     */
    readonly parameterId: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#parameter_name DcsInstanceV1#parameter_name}.
     *
     * @stability stable
     */
    readonly parameterName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#parameter_value DcsInstanceV1#parameter_value}.
     *
     * @stability stable
     */
    readonly parameterValue: string;
}
export declare function dcsInstanceV1ConfigurationToTerraform(struct?: DcsInstanceV1Configuration | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export interface DcsInstanceV1Timeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#create DcsInstanceV1#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#delete DcsInstanceV1#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1#update DcsInstanceV1#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
export declare function dcsInstanceV1TimeoutsToTerraform(struct?: DcsInstanceV1TimeoutsOutputReference | DcsInstanceV1Timeouts | cdktf.IResolvable): any;
/**
 * @stability stable
 */
export declare class DcsInstanceV1TimeoutsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
     * @param terraformResource The parent resource.
     * @param terraformAttribute The attribute on the parent resource this class is referencing.
     * @param isSingleItem True if this is a block, false if it's a list.
     * @stability stable
     */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, isSingleItem: boolean);
    /**
     * @stability stable
     */
    get internalValue(): DcsInstanceV1Timeouts | undefined;
    /**
     * @stability stable
     */
    set internalValue(value: DcsInstanceV1Timeouts | undefined);
    private _create?;
    /**
     * @stability stable
     */
    get create(): string;
    /**
     * @stability stable
     */
    set create(value: string);
    /**
     * @stability stable
     */
    resetCreate(): void;
    /**
     * @stability stable
     */
    get createInput(): string | undefined;
    private _delete?;
    /**
     * @stability stable
     */
    get delete(): string;
    /**
     * @stability stable
     */
    set delete(value: string);
    /**
     * @stability stable
     */
    resetDelete(): void;
    /**
     * @stability stable
     */
    get deleteInput(): string | undefined;
    private _update?;
    /**
     * @stability stable
     */
    get update(): string;
    /**
     * @stability stable
     */
    set update(value: string);
    /**
     * @stability stable
     */
    resetUpdate(): void;
    /**
     * @stability stable
     */
    get updateInput(): string | undefined;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1 opentelekomcloud_dcs_instance_v1}.
 *
 * @stability stable
 */
export declare class DcsInstanceV1 extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/opentelekomcloud/r/dcs_instance_v1 opentelekomcloud_dcs_instance_v1} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DcsInstanceV1Config);
    private _accessUser?;
    /**
     * @stability stable
     */
    get accessUser(): string;
    /**
     * @stability stable
     */
    set accessUser(value: string);
    /**
     * @stability stable
     */
    resetAccessUser(): void;
    /**
     * @stability stable
     */
    get accessUserInput(): string | undefined;
    private _availableZones?;
    /**
     * @stability stable
     */
    get availableZones(): string[];
    /**
     * @stability stable
     */
    set availableZones(value: string[]);
    /**
     * @stability stable
     */
    get availableZonesInput(): string[] | undefined;
    private _backupAt?;
    /**
     * @stability stable
     */
    get backupAt(): number[];
    /**
     * @stability stable
     */
    set backupAt(value: number[]);
    /**
     * @stability stable
     */
    resetBackupAt(): void;
    /**
     * @stability stable
     */
    get backupAtInput(): number[] | undefined;
    private _backupType?;
    /**
     * @stability stable
     */
    get backupType(): string;
    /**
     * @stability stable
     */
    set backupType(value: string);
    /**
     * @stability stable
     */
    resetBackupType(): void;
    /**
     * @stability stable
     */
    get backupTypeInput(): string | undefined;
    private _beginAt?;
    /**
     * @stability stable
     */
    get beginAt(): string;
    /**
     * @stability stable
     */
    set beginAt(value: string);
    /**
     * @stability stable
     */
    resetBeginAt(): void;
    /**
     * @stability stable
     */
    get beginAtInput(): string | undefined;
    private _capacity?;
    /**
     * @stability stable
     */
    get capacity(): number;
    /**
     * @stability stable
     */
    set capacity(value: number);
    /**
     * @stability stable
     */
    get capacityInput(): number | undefined;
    /**
     * @stability stable
     */
    get createdAt(): string;
    private _description?;
    /**
     * @stability stable
     */
    get description(): string;
    /**
     * @stability stable
     */
    set description(value: string);
    /**
     * @stability stable
     */
    resetDescription(): void;
    /**
     * @stability stable
     */
    get descriptionInput(): string | undefined;
    private _engine?;
    /**
     * @stability stable
     */
    get engine(): string;
    /**
     * @stability stable
     */
    set engine(value: string);
    /**
     * @stability stable
     */
    get engineInput(): string | undefined;
    private _engineVersion?;
    /**
     * @stability stable
     */
    get engineVersion(): string;
    /**
     * @stability stable
     */
    set engineVersion(value: string);
    /**
     * @stability stable
     */
    get engineVersionInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get internalVersion(): string;
    /**
     * @stability stable
     */
    get ip(): string;
    private _maintainBegin?;
    /**
     * @stability stable
     */
    get maintainBegin(): string;
    /**
     * @stability stable
     */
    set maintainBegin(value: string);
    /**
     * @stability stable
     */
    resetMaintainBegin(): void;
    /**
     * @stability stable
     */
    get maintainBeginInput(): string | undefined;
    private _maintainEnd?;
    /**
     * @stability stable
     */
    get maintainEnd(): string;
    /**
     * @stability stable
     */
    set maintainEnd(value: string);
    /**
     * @stability stable
     */
    resetMaintainEnd(): void;
    /**
     * @stability stable
     */
    get maintainEndInput(): string | undefined;
    /**
     * @stability stable
     */
    get maxMemory(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    /**
     * @stability stable
     */
    get orderId(): string;
    private _password?;
    /**
     * @stability stable
     */
    get password(): string;
    /**
     * @stability stable
     */
    set password(value: string);
    /**
     * @stability stable
     */
    get passwordInput(): string | undefined;
    private _periodType?;
    /**
     * @stability stable
     */
    get periodType(): string;
    /**
     * @stability stable
     */
    set periodType(value: string);
    /**
     * @stability stable
     */
    resetPeriodType(): void;
    /**
     * @stability stable
     */
    get periodTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get port(): number;
    private _productId?;
    /**
     * @stability stable
     */
    get productId(): string;
    /**
     * @stability stable
     */
    set productId(value: string);
    /**
     * @stability stable
     */
    get productIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get resourceSpecCode(): string;
    private _saveDays?;
    /**
     * @stability stable
     */
    get saveDays(): number;
    /**
     * @stability stable
     */
    set saveDays(value: number);
    /**
     * @stability stable
     */
    resetSaveDays(): void;
    /**
     * @stability stable
     */
    get saveDaysInput(): number | undefined;
    private _securityGroupId?;
    /**
     * @stability stable
     */
    get securityGroupId(): string;
    /**
     * @stability stable
     */
    set securityGroupId(value: string);
    /**
     * @stability stable
     */
    get securityGroupIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get securityGroupName(): string;
    /**
     * @stability stable
     */
    get status(): string;
    private _subnetId?;
    /**
     * @stability stable
     */
    get subnetId(): string;
    /**
     * @stability stable
     */
    set subnetId(value: string);
    /**
     * @stability stable
     */
    get subnetIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get subnetName(): string;
    /**
     * @stability stable
     */
    get usedMemory(): number;
    /**
     * @stability stable
     */
    get userId(): string;
    /**
     * @stability stable
     */
    get userName(): string;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    /**
     * @stability stable
     */
    get vpcName(): string;
    private _backupPolicy;
    /**
     * @stability stable
     */
    get backupPolicy(): DcsInstanceV1BackupPolicyOutputReference;
    /**
     * @stability stable
     */
    putBackupPolicy(value: DcsInstanceV1BackupPolicy): void;
    /**
     * @stability stable
     */
    resetBackupPolicy(): void;
    /**
     * @stability stable
     */
    get backupPolicyInput(): DcsInstanceV1BackupPolicy | undefined;
    private _configuration?;
    /**
     * @stability stable
     */
    get configuration(): DcsInstanceV1Configuration[] | cdktf.IResolvable;
    /**
     * @stability stable
     */
    set configuration(value: DcsInstanceV1Configuration[] | cdktf.IResolvable);
    /**
     * @stability stable
     */
    resetConfiguration(): void;
    /**
     * @stability stable
     */
    get configurationInput(): cdktf.IResolvable | DcsInstanceV1Configuration[] | undefined;
    private _timeouts;
    /**
     * @stability stable
     */
    get timeouts(): DcsInstanceV1TimeoutsOutputReference;
    /**
     * @stability stable
     */
    putTimeouts(value: DcsInstanceV1Timeouts): void;
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): DcsInstanceV1Timeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
